### Praat Stimmprofil
# Joerg Mayer, jmayer@lingphon.net
# This is free software under the terms of the GNU General Public License 3


### initialize picture
include stimmprofil_initpic.praat


### first call (from stimmprofil_init): display some instructions and exit
if not fileReadable (recordingSpec$)
	clearinfo
	Select inner viewport: 0, 6, 0, 9
	Axes: 0, 6, 9, 0
	Paint rounded rectangle: "Yellow", 1, 5, 3, 6, 3
	Draw rounded rectangle: 1, 5, 3, 6, 3
	Text special: 1.5, "left", 3.5, "half", "Helvetica", 10, "0", "Öffnen Sie eine Aufnahme,"
	Text special: 1.5, "left", 3.75, "half", "Helvetica", 10, "0", "wählen Sie einen geeigneten Abschnitt aus"
	Text special: 1.5, "left", 4.0, "half", "Helvetica", 10, "0", "und klicken Sie:"
	Text special: 1.5, "left", 4.5, "half", "Helvetica", 10, "0", "##Pulses > Stimmprofil: Stimmprobe hinzufügen...#"
	writeFile: recordingSpec$, 1
	exitScript()
endif



### settings
colors$ [1] = "Navy"
colors$ [2] = "Cyan"
colors$ [3] = "Teal"
colors$ [4] = "Olive" ;Maroon
maxMeanPitch = 0
minMeanPitch = 10000
maxPitchSD = 0
maxPitch = 0
minPitch = 10000
maxST = 0
maxJitterLoc = 0
maxShimmerLoc = 0
maxShimmerdB = 0
maxCPPS = 0
minSlope = 10000
minTilt = 10000
maxHNR = 0
maxH1H2 = 0
minH1H2 = 10000
maxNVB = 0
maxDVB = 0
maxVoiceBreaks = 0
maxAVQI = 0
minAVQI = 10000


### read & extract data and determine max and min values
recordings = readFile (recordingSpec$)
for rec to recordings
	data$ = readFile$ (tempFile$ + string$ (rec))
	aufnahmedatum$ [rec] = extractLine$ (data$, "aufnahmedatum: ")
	aufnahmetyp [rec] = extractNumber (data$, "aufnahmetyp:")
	beschreibung$ [rec] = extractLine$ (data$, "beschreibung: ")
	vlen_raw [rec] = extractNumber (data$, "vlen_raw:")
	tlen_raw [rec] = extractNumber (data$, "tlen_raw:")
	tlen_sth [rec] = extractNumber (data$, "tlen_sth:")
	h1h2 [rec] = extractNumber (data$, "h1h2:")
	if h1h2 [rec] <> undefined and h1h2 [rec] > maxH1H2
		maxH1H2 = h1h2 [rec]
	endif
	if h1h2 [rec] <> undefined and h1h2 [rec] < minH1H2
		minH1H2 = h1h2 [rec]
	endif
	meanPitch [rec] = extractNumber (data$, "meanPitch:")
	if meanPitch [rec] <> undefined and meanPitch [rec] > maxMeanPitch
		maxMeanPitch = meanPitch [rec]
	endif
	if meanPitch [rec] <> undefined and meanPitch [rec] < minMeanPitch
		minMeanPitch = meanPitch [rec]
	endif
	sdPitch [rec] = extractNumber (data$, "sdPitch:")
	if sdPitch [rec] <> undefined and sdPitch [rec] > maxPitchSD
		maxPitchSD = sdPitch [rec]
	endif
	minimumPitch [rec] = extractNumber (data$, "minimumPitch:")
	if minimumPitch [rec] <> undefined and minimumPitch [rec] < minPitch
		minPitch = minimumPitch [rec]
	endif
	maximumPitch [rec] = extractNumber (data$, "maximumPitch:")
	if maximumPitch [rec] <> undefined and maximumPitch [rec] > maxPitch
		maxPitch = maximumPitch [rec]
	endif
	semitones [rec]= extractNumber (data$, "semitones:")
	if semitones [rec] <> undefined and semitones [rec] > maxST
		maxST = semitones [rec]
	endif
	jitterLoc [rec] = extractNumber (data$, "jitterLoc:")
	if jitterLoc [rec] <> undefined and jitterLoc [rec] > maxJitterLoc
		maxJitterLoc = jitterLoc [rec]
	endif
	shimmerLoc [rec] = extractNumber (data$, "shimmerLoc:")
	if shimmerLoc [rec] <> undefined and shimmerLoc [rec] > maxShimmerLoc
		maxShimmerLoc = shimmerLoc [rec]
	endif
	shimmerdB [rec] = extractNumber (data$, "shimmerdB:")
	if shimmerdB [rec] <> undefined and shimmerdB [rec] > maxShimmerdB
		maxShimmerdB = shimmerdB [rec]
	endif
	cpps [rec] = extractNumber (data$, "cpps:")
	if cpps [rec] <> undefined and cpps [rec] > maxCPPS
		maxCPPS = cpps [rec]
	endif
	slope [rec] = extractNumber (data$, "slope:")
	if slope [rec] <> undefined and slope [rec] <> undefined and slope [rec] < minSlope
		minSlope = slope [rec]
	endif
	tilt [rec] = extractNumber (data$, "tilt:")
	if tilt [rec] <> undefined and tilt [rec] <> undefined and tilt [rec] > minTilt
		minTilt = tilt [rec]
	endif
	meanHNR [rec] = extractNumber (data$, "meanHNR:")
	if meanHNR [rec] <> undefined and meanHNR [rec] > maxHNR
		maxHNR = meanHNR [rec]
	endif
	if aufnahmetyp [rec] = 1
		voiceBreaks [rec] = extractNumber (data$, "voiceBreaks:")
		if voiceBreaks [rec] <> undefined and voiceBreaks [rec] > maxVoiceBreaks
			maxVoiceBreaks = voiceBreaks [rec]
		endif
	endif
	if aufnahmetyp [rec] = 3
		avqi [rec] = extractNumber (data$, "avqi:")
		avqi1type [rec] = extractNumber (data$, "avqi1type:")
		avqi1desc$ [rec] = extractLine$ (data$, "avqi1desc: ")
		avqi1date$ [rec] = extractLine$ (data$, "avqi1date: ")
		avqiversion$ [rec] = extractLine$ (data$, "avqiversion: ")
		if avqi [rec] <> undefined and avqi [rec] > maxAVQI
			maxAVQI = avqi [rec]
		endif
		if avqi [rec] <> undefined and avqi [rec] < minAVQI
			minAVQI = avqi [rec]
		endif
	endif
endfor

redMarksY = recordings+((recordings/100)*12)

### generate output
footnote2 = 0
for rec to recordings
	color$ = colors$ [rec]
	y1 = (recordings-(rec-1))-0.1
	y2 = y1-0.8
	y3 = y1-0.4

	###### recording data
	Font size: 8
	Select inner viewport: 0.5, 5.5, 1, 2.3
	Axes: 0, 6, 0, 3
	do (color$)
	Paint rectangle: color$, 0, 0.1, 3.75-rec*0.75, 3-rec*0.75
	if aufnahmetyp [rec] = 1 or (aufnahmetyp [rec] = 3 and avqi1type [rec] = 2)
		aufnahmetyp1$ = "Text: "
		aufnahmetyp$ = "Vokal: "
	else
		aufnahmetyp1$ = "Vokal: "
		aufnahmetyp$ = "Text: "
	endif
	vdur$ = fixed$ (vlen_raw [rec], 2)
	tdur$ = fixed$ (tlen_raw [rec], 2)
	tdur_sth$ = fixed$ (tlen_sth [rec], 2)
	if aufnahmetyp [rec] = 1
		Text special: 0.15, "left", (3.75-rec*0.75)-0.25, "half", "Helvetica", 8, "0", aufnahmetyp$ + beschreibung$ [rec]
		Text special: 0.15, "left", (3.75-rec*0.75)-0.55, "half", "Helvetica", 8, "0", "Dauer: " + vdur$ + " s"
		Text special: 5.95, "right", (3.75-rec*0.75)-0.57, "half", "Helvetica", 6, "0", "Aufnahmedatum: " + aufnahmedatum$ [rec]
	elsif aufnahmetyp [rec] = 2
		Text special: 0.15, "left", (3.75-rec*0.75)-0.25, "half", "Helvetica", 8, "0", aufnahmetyp$ + beschreibung$ [rec]
		Text special: 0.15, "left", (3.75-rec*0.75)-0.55, "half", "Helvetica", 8, "0", "Dauer: " + tdur$ + " s   (stimmhafte Anteile: " + tdur_sth$ + " s)"
		Text special: 5.95, "right", (3.75-rec*0.75)-0.57, "half", "Helvetica", 6, "0", "Aufnahmedatum: " + aufnahmedatum$ [rec]
	else
		if aufnahmetyp1$ = "Text: "
			Text special: 0.15, "left", (3.75-rec*0.75)-0.25, "half", "Helvetica", 8, "0", aufnahmetyp1$ + avqi1desc$ [rec] + "   Dauer: " + tdur$ + " s   (stimmh. Anteile: " + tdur_sth$ + " s)"
			Text special: 5.95, "right", (3.75-rec*0.75)-0.27, "half", "Helvetica", 6, "0", "Aufnahmedatum: " + avqi1date$ [rec]
			Text special: 0.15, "left", (3.75-rec*0.75)-0.55, "half", "Helvetica", 8, "0", aufnahmetyp$ + beschreibung$ [rec] + "   Dauer: " + vdur$ + " s"
			Text special: 5.95, "right", (3.75-rec*0.75)-0.57, "half", "Helvetica", 6, "0", "Aufnahmedatum: " + aufnahmedatum$ [rec]
		else
			Text special: 0.15, "left", (3.75-rec*0.75)-0.25, "half", "Helvetica", 8, "0", aufnahmetyp$ + beschreibung$ [rec] + "   Dauer: " + tdur$ + " s   (stimmh. Anteile: " + tdur_sth$ + " s)"
			Text special: 5.95, "right", (3.75-rec*0.75)-0.27, "half", "Helvetica", 6, "0", "Aufnahmedatum: " + aufnahmedatum$ [rec]
			Text special: 0.15, "left", (3.75-rec*0.75)-0.55, "half", "Helvetica", 8, "0", aufnahmetyp1$ + avqi1desc$ [rec] + "   Dauer: " + vdur$ + " s   vom " + avqi1date$ [rec]
			Text special: 5.95, "right", (3.75-rec*0.75)-0.57, "half", "Helvetica", 6, "0", "Aufnahmedatum: " + avqi1date$ [rec]
		endif
	endif
	do ("Black")
	Line width... 0.1
	Draw line: 0, 2.25, 6, 2.25
	Draw line: 0, 1.5, 6, 1.5
	Draw line: 0, 0.75, 6, 0.75
	Line width: 1
	Draw rectangle... 0 6 0 3
	Font size: 6

	### min/max, mean, sd pitch
	lower = minPitch - 20
	upper = maxPitch + 20
	@viewport_axes: 2.55, 2.95, 4.8
	if rec = 1
		@inner_box
		if upper-lower < 150 and upper-lower > 0
			Marks bottom every: 1, 25, "yes", "yes", "no"
		elsif upper-lower < 250 and upper-lower > 0
			Marks bottom every: 1, 50, "yes", "yes", "no"
		elsif upper-lower >= 250
			Marks bottom every: 1, 100, "yes", "yes", "no"
		endif
	endif
	y4 = y1-0.3
	y5 = y1-0.5
	@set_left_edge
	if minimumPitch [rec] <> undefined and maximumPitch [rec] <> undefined and meanPitch [rec] <> undefined and sdPitch [rec] <> undefined
		mipi = minimumPitch [rec]
		mapi = maximumPitch [rec]
		mepi = meanPitch [rec]
		sdpi = sdPitch [rec]
		mipi$ = fixed$ (mipi, 0)
		mapi$ = fixed$ (mapi, 0)
		mepi$ = fixed$ (mepi, 0)
		sdpi$ = fixed$ (sdpi, 1)
		Paint rectangle: color$, mipi, mapi, y1, y2
		Text special: upper+leftEdge, "Left", y3, "Half", "Helvetica", 5, "0", "x\-^=" + mepi$ + ", sd=" + sdpi$
		Text special: lower-leftEdge, "Right", y3, "Half", "Helvetica", 5, "0", "min=" + mipi$ + ", max=" + mapi$
		do ("White")
		Line width: 1
		Draw line: mepi, y1, mepi, y2
		Draw line: mepi-sdpi, y4, mepi-sdpi, y5
		Draw line: mepi+sdpi, y4, mepi+sdpi, y5
		Draw line: mepi-sdpi, y3, mepi+sdpi, y3
		Line width: 0.1
	else
		mipi$ = "undefined"
		mapi$ = "undefined"
		mepi$ = "undefined"
		sdpi$ = "undefined"
		Text special: upper+leftEdge, "Left", y3, "Half", "Helvetica", 5, "0", "k.A.^*^*"
		footnote2 = 1
	endif

	### semitones
	lower = 0
	if maxST < 5
		upper = 5
		marksDist = 1
	else
		upper = maxST + 6
		marksDist = 5
	endif
	@viewport_axes: 3.15, 3.55, 0
	if rec = 1
		@inner_box
		Marks bottom every: 1, marksDist, "yes", "yes", "no"
	endif
	thisst = semitones [rec]
	@paint_write_data: thisst, " st", lower, 0
	thisst$ = paint_write_data.data$

	### jitter percent
	thresh = 0.8
	lower = 0
	if maxJitterLoc < 2
		upper = 2
	else
		upper = (ceiling (maxJitterLoc)) + 2
	endif
	@viewport_axes: 3.8, 4.15, 0
	if rec = 1
		@draw_arrow: "l"
		if upper > 5
			Marks bottom every: 1, 1, "yes", "yes", "no"
		else
			Marks bottom every: 1, 0.5, "yes", "yes", "no"
		endif
	endif
	jitt = jitterLoc [rec]
	@paint_write_data: jitt, " \% ", lower, 0
	jitt$ = paint_write_data.data$

	### shimmer percent
	thresh = 3.8
	lower = 0
	if maxShimmerLoc < 9
		upper = 10
	else
		upper = (ceiling (maxShimmerLoc)) + 3
	endif
	@viewport_axes: 4.4, 4.75, 0
	if rec = 1
		@draw_arrow: "l"
		if upper > 10
			Marks bottom every: 1, 4, "yes", "yes", "no"
		else
			Marks bottom every: 1, 2, "yes", "yes", "no"
		endif
	endif
	shimpc = shimmerLoc [rec]
	@paint_write_data: shimpc, " \% ", lower, 0
	shimpc$ = paint_write_data.data$

	### HNR
	lower = 0
	upper = 35
	if maxHNR > 30
		upper = maxHNR + (0.2 * maxHNR)
	endif
	@viewport_axes: 5, 5.35, 0
	if rec = 1
		@draw_arrow: "r"
		Marks bottom every: 1, 10, "yes", "yes", "no"
	endif
	hnr = meanHNR [rec]
	@paint_write_data: hnr, " dB", lower, 0
	hnr$ = paint_write_data.data$

	### H1-H2
	lower = -8
	upper = 8
	if minH1H2 < -6
		lower = minH1H2 - 3
	endif
	if maxH1H2 > 6
		upper = maxH1H2 + 3
	endif
	@viewport_axes: 5.6, 5.95, 0
	if rec = 1
		@inner_box
		if abs (lower) + upper > 16
			Marks bottom every: 1, 4, "yes", "yes", "no"
		else
			Marks bottom every: 1, 2, "yes", "yes", "no"
		endif
		Red
		xmid = upper - (0.5 * (upper - lower))
		uthresh = 4
		lthresh = -4
		arrowwidth = Horizontal mm to wc: 5
		Arrow size: 0.5
		Draw arrow: lthresh-arrowwidth, redMarksY, lthresh, redMarksY
		Draw arrow: uthresh+arrowwidth, redMarksY, uthresh, redMarksY
		Text special: 0, "centre", redMarksY, "half", "Helvetica", 5, "0", "besser"
	endif
	h1_h2 = h1h2 [rec]
	@paint_write_data: h1_h2, " dB", 0, 0
	h1_h2$ = paint_write_data.data$

	### Slope
	upper = 0
	lower = -40
	if minSlope < -38
		lower = floor (minSlope) - 5
	endif
	@viewport_axes: 6.2, 6.55, 0
	if rec = 1
		# @draw_arrow: "???"
		@inner_box
		if lower < -40
			Marks bottom every: 1, 10, "yes", "yes", "no"
		else
			Marks bottom every: 1, 5, "yes", "yes", "no"
		endif
	endif
	Colour: 0.35
	arrowwidth = Horizontal mm to wc: 5
	Arrow size: 0.5
	Draw arrow: upper-arrowwidth, redMarksY, upper, redMarksY
	Draw arrow: lower+arrowwidth, redMarksY, lower, redMarksY
	Colour: 0.2
	Text special: lower+arrowwidth, "left", redMarksY, "half", "Helvetica", 5, "0", " stärker geneigt"
	Text special: upper-arrowwidth, "right", redMarksY, "half", "Helvetica", 5, "0", " weniger geneigt"
	sslope = slope [rec]
	@paint_write_data: sslope, " dB", upper, 1
	sslope$ = paint_write_data.data$

	### CPPS
	thresh = 0
	lower = 0
	upper = 20
	if maxCPPS > 18
		upper = (ceiling (maxCPPS)) + 3
	endif
	@viewport_axes: 6.8, 7.15, 0
	if rec = 1
		@draw_arrow: "r"
		if upper > 20
			Marks bottom every: 1, 4, "yes", "yes", "no"
		else
			Marks bottom every: 1, 2, "yes", "yes", "no"
		endif
	endif
	scpp = cpps [rec]
	@paint_write_data: scpp, " dB", lower, 0
	scpp$ = paint_write_data.data$

	### voice breaks
	lower = 0
	upper = 4
	if maxVoiceBreaks > 3
		upper = (ceiling (maxVoiceBreaks)) + 3
	endif
	@viewport_axes: 7.4, 7.75, 0
	if rec = 1
		@draw_arrow: "l"
		if upper <= 6
			Marks bottom every: 1, 1, "yes", "yes", "no"
		elsif upper > 6 and upper <= 12
			Marks bottom every: 1, 2, "yes", "yes", "no"
		else
			Marks bottom every: 1, 4, "yes", "yes", "no"
		endif
	endif
	if aufnahmetyp [rec] = 1
		vbDeg = voiceBreaks [rec]
		@paint_write_data: vbDeg, " \% ", lower, 0
		vbDeg$ = paint_write_data.data$
	else
		@set_left_edge
		Text special: upper+leftEdge, "Left", y3, "Half", "Helvetica", 5, "0", "k.A.^* "
	endif

	### AVQI
	lower = 0
	upper = 10
	if minAVQI < 0
		lower = minAVQI - 1
	endif
	if maxAVQI > 10
		upper = (ceiling (maxAVQI)) + 3
	endif
	@viewport_axes: 8, 8.35, 0
	if rec = 1
		@draw_arrow: "l"
		if upper = 10
			Marks bottom every: 1, 1, "yes", "yes", "no"
		else
			Marks bottom every: 1, 2, "yes", "yes", "no"
		endif
	endif
	if aufnahmetyp [rec] = 3
		theAVQI = avqi [rec]
		theVersion$ = " (" + avqiversion$ [rec] + ")"
		@paint_write_data: theAVQI, theVersion$, 0, 0
		theAVQI$ = paint_write_data.data$ + theVersion$
	else
		@set_left_edge
		Text special: upper+leftEdge, "Left", y3, "Half", "Helvetica", 5, "0", "k.A.^* "
	endif

	### shimmer db
	if shimmerdB [rec] <> undefined
		shimdb = shimmerdB [rec]
		shimdb$ = fixed$ (shimdb, 2)
	else
		shimdb$ = "undefined"
	endif
	### Tilt
	if tilt [rec] <> undefined
		stilt = tilt [rec]
		stilt$ = fixed$ (stilt, 2)
	else
		stilt$ = "undefined"
	endif
endfor

### procedures for data output
procedure viewport_axes: .vr1 .vr2, .hr2
	if .hr2 = 0
		.hr2 = 5
	endif
	Select inner viewport: 3.5, .hr2, .vr1, .vr2
	Axes: lower, upper, 0, recordings	
endproc

procedure inner_box
	Black
	Line width: 0.1
	Draw inner box
endproc

procedure draw_arrow: .direction$
	Red
	arrowwidth = Horizontal mm to wc: 10
	Arrow size: 0.5
	if .direction$ = "r"
		Draw arrow: lower, redMarksY, lower+arrowwidth, redMarksY
	elsif .direction$ = "l"
		Draw arrow: lower+arrowwidth, redMarksY, lower, redMarksY
	endif
	Text special: lower+arrowwidth, "left", redMarksY, "half", "Helvetica", 5, "0", " besser"
	@inner_box
endproc

procedure set_left_edge
	leftEdge = ((upper - lower)/100) * 2
	do (color$)
endproc

procedure paint_write_data: .data, .unit$, .start, .permute_lower_upper
	@set_left_edge
	if .data <> undefined
		.data$ = fixed$ (.data, 2)
		if not .permute_lower_upper
			Paint rectangle: color$, .start, .data, y1, y2
		else
			Paint rectangle: color$, .data, .start, y1, y2
		endif
		Text special: upper+leftEdge, "Left", y3, "Half", "Helvetica", 5, "0", .data$ + .unit$
	else
		.data$ = "undefined"
		Text special: upper+leftEdge, "Left", y3, "Half", "Helvetica", 5, "0", "k.A.^*^*"
		footnote2 = 1
	endif
endproc


### footnote 2
if footnote2 = 1
	Black
	Select inner viewport... 0.5 5.5 2.5 8.5
	Axes... 0 5 0 10
	Text special: 5, "right", -0.14, "top", "Helvetica", 5, "0", "^*^* Der Parameter konnte mangels Daten nicht berechnet werden."
endif


### text output
if recordings = 1
	appendInfoLine: "Praat-Stimmprofil"
	appendInfoLine: "Datum: " + datum$ + ", Untersucher: " + untersucher$ + newline$
	appendInfoLine: "Name: " + name$
	appendInfoLine: "Geburtsdatum: " + geburtsdatum$
	appendInfoLine: "Befund: " + befund$
endif
appendInfoLine: newline$ + "Stimmprobe ", recordings, ":"
if aufnahmetyp [recordings] = 3
	appendInfo: left$ (aufnahmetyp1$, length (aufnahmetyp1$)-2) + " (" + avqi1desc$ [recordings] + ") vom " + avqi1date$ [recordings] + " + "
endif
appendInfoLine: left$ (aufnahmetyp$, length (aufnahmetyp$)-2) + " (" + beschreibung$ [recordings] + ") vom " + aufnahmedatum$ [recordings]
if aufnahmetyp [recordings] = 1
	appendInfoLine: tab$ + "Dauer: ", vdur$, "s"
elsif aufnahmetyp [recordings] = 2
	appendInfoLine: tab$ + "Dauer: ", tdur$, "s (sth. Anteile: ", tdur_sth$, "s)"
elsif aufnahmetyp [recordings] = 3
	appendInfoLine: tab$ + "Vokalauer: ", vdur$, "s / Textdauer: ", tdur$, "s (sth. Anteile: ", tdur_sth$, "s)"
endif
appendInfoLine: tab$ + "Pitch Minimum (Hz): ", mipi$
appendInfoLine: tab$ + "Pitch Maximum (Hz): ", mapi$
appendInfoLine: tab$ + "Pitch Mittelwert (Hz): ", mepi$
appendInfoLine: tab$ + "Pitch Standardabweichung (Hz): ", sdpi$
appendInfoLine: tab$ + "Stimmumfang (st): ", thisst$
appendInfoLine: tab$ + "Jitter local (%): ", jitt$
appendInfoLine: tab$ + "Shimmer local (%): ", shimpc$
appendInfoLine: tab$ + "Shimmer local (dB): ", shimdb$
appendInfoLine: tab$ + "Harmonics-to-noise ratio (dB): ", hnr$
appendInfoLine: tab$ + "H1-H2 (dB): ", h1_h2$
appendInfoLine: tab$ + "Slope (dB): ", sslope$
appendInfoLine: tab$ + "Tilt (dB): ", stilt$
appendInfoLine: tab$ + "CPPS: ", scpp$
if aufnahmetyp [recordings] = 1
	appendInfoLine: tab$ + "Degree of voice breaks (%): ", vbDeg$
endif
if aufnahmetyp [recordings] = 3
	appendInfoLine: tab$ + "AVQI: ", theAVQI$
endif



Select inner viewport... 0 5.5 0 9
writeFile: recordingSpec$, recordings + 1


