### Praat Stimmprofil
# Joerg Mayer, jmayer@lingphon.net
# This is free software under the terms of the GNU General Public License 3

endeditor



### read general data
gdata$ = readFile$ (defaultDirectory$ + "/stimmprofil0")
untersucher$ = extractLine$ (gdata$, "untersucher: ")
datum$ = extractLine$ (gdata$, "datum: ")
mikrophon$ = extractLine$ (gdata$, "mikrophon: ")
aD_Wandler$ = extractLine$ (gdata$, "aD_Wandler: ")
aD_Parameter$ = extractLine$ (gdata$, "aD_Parameter: ")
computer$ = extractLine$ (gdata$, "computer: ")
betriebssystem$ = extractLine$ (gdata$, "betriebssystem: ")
name$ = extractLine$ (gdata$, "name: ")
geburtsdatum$ = extractLine$ (gdata$, "geburtsdatum: ")
geschlecht = extractNumber (gdata$, "geschlecht:")
befund$ = extractLine$ (gdata$, "befund: ")

### fetch version
version$ = readFile$ (defaultDirectory$ + "/VERSION")
pspversion$ = replace_regex$ (version$, "\s\d+.*$", "", 0)

### adapt some variables
tech_data = 0
if geschlecht = 1
	anrede$ = "Frau "
else
	anrede$ = "Herr "
endif
if mikrophon$ <> ""
	mikrophon$ = mikrophon$ + "     "
	tech_data = 1
else
	mikrophon$ = "k.A.     "
endif
if computer$ <> ""
	computer$ = computer$ + "     "
	tech_data = 1
else
	computer$ = "k.A.     "
endif
if betriebssystem$ <> ""
	betriebssystem$ = betriebssystem$ + "     "
else
	betriebssystem$ = "k.A.     "
endif
if aD_Parameter$ <> ""
	aD_Parameter$ = aD_Parameter$
	tech_data = 1
else
	aD_Parameter$ = "k.A."
endif
if aD_Wandler$ <> ""
	aD_Wandler$ = aD_Wandler$ + "     "
	tech_data = 1
else
	aD_Wandler$ = "k.A.     "
endif
if tech_data
	tech_data$ = "Computer: " + computer$ + "OS: " + betriebssystem$ + "Mikrophon: " + mikrophon$ + "AD-Wandler: " + aD_Wandler$ + "AD-Parameter: " + aD_Parameter$
else
	tech_data$ = ""
endif

### initialize output
Erase all
Font size: 10
Helvetica
Black
Solid line

### output: logo
Select inner viewport: 0.5, 5.5, 0, 1
Axes: 0, 5, 0, 1
Text special: 1, "centre", 0.5, "half", "Helvetica", 14, "0", "##Praat-Stimmprofil#"
Grey
Text special: 1.8, "right", 0.35, "half", "Helvetica", 5, "0", pspversion$
Black
Line width... 3
Draw rounded rectangle: 0, 2, 0.15, 0.8, 3.0

### output: header
Line width... 1
Draw rectangle: 2.1, 5, 0.15, 0.8
Text special: 2.15, "left", 0.7, "half", "Helvetica", 8, "0", "##Name:# " + anrede$ + name$
Text special: 2.15, "left", 0.55, "half", "Helvetica", 8, "0", "##Geburtsdatum:# " + geburtsdatum$
Text special: 2.15, "left", 0.4, "half", "Helvetica", 8, "0", "##Befund:#"
Text special: 2.15, "left", 0.25, "half", "Helvetica", 8, "0", befund$

### output: footer
Line width... 1
Select inner viewport... 0.5 5.5 8.75 9
Axes... 0 6 0 1
Draw rectangle... 0 6 0 1
Text special: 0.1, "left", 0.5, "half", "Helvetica", 8, "0", "##Datum:# " + datum$ + "        ##Untersucher:# " + untersucher$
Text special: 5.9, "right", 0.5, "half", "Helvetica", 6, "0", "Praat " + string$(praatVersion)

### output: headings and data layout
Select inner viewport... 0.5 5.5 2.5 8.5
Axes... 0 5 0 10
Text special: 0, "left", 10.15, "half", "Helvetica", 6, "0", tech_data$
Draw rectangle... 0 5 0 10

Text special: 0.1, "left", 9.0, "half", "Helvetica", 8, "0", "Grundfrequenz"
Text special: 1.1, "left", 9.7, "half", "Helvetica", 6, "0", "Min, Max, Mittelwert (x\-^),"
Text special: 1.1, "left", 9.55, "half", "Helvetica", 6, "0", "Standardabweichung (sd)"
Text special: 1.1, "left", 9.4, "half", "Helvetica", 6, "0", "(alle Angaben in Hz)"
Text special: 1.1, "left", 8.5, "half", "Helvetica", 6, "0", "Stimmumfang in Halbtonschritten (st)"

Text special: 0.1, "left", 7, "half", "Helvetica", 8, "0", "Perturbation"
Text special: 1.1, "left", 7.5, "half", "Helvetica", 6, "0", "Jitter local"
Text special: 1.1, "left", 6.5, "half", "Helvetica", 6, "0", "Shimmer local"

Text special: 0.1, "left", 5.5, "half", "Helvetica", 8, "0", "Harmonizität"
Text special: 1.1, "left", 5.5, "half", "Helvetica", 6, "0", "Harmonics-to-Noise Ratio (HNR)"

Text special: 0.1, "left", 4, "half", "Helvetica", 8, "0", "Spektrum"
Text special: 1.1, "left", 4.5, "half", "Helvetica", 6, "0", "H1 \-m H2"
Text special: 1.1, "left", 3.5, "half", "Helvetica", 6, "0", "Neigung (LTAS Slope)"

Text special: 0.1, "left", 2.5, "half", "Helvetica", 8, "0", "Cepstrum"
Text special: 1.1, "left", 2.5, "half", "Helvetica", 6, "0", "Smothed Cepstral Peak Prominence (CPPS)"

Text special: 0.1, "left", 1.5, "half", "Helvetica", 8, "0", "Stimmabbrüche"
Text special: 1.1, "left", 1.5, "half", "Helvetica", 6, "0", "Degree of voice breaks"

Text special: 0.1, "left", 0.5, "half", "Helvetica", 8, "0", "Stimmqualität"
Text special: 1.1, "left", 0.5, "half", "Helvetica", 6, "0", "Acoustic Voice Quality Index"

# footnote 1
Text special: 5, "right", 0, "top", "Helvetica", 5, "0", "^* Stimmabbrüche und AVQI werden nur bei geeigneten Stimmproben berechnet."

### draw lines
Line width... 1
Draw line... 0 8 5 8
Draw line... 0 6 5 6
Draw line... 0 5 5 5
Draw line... 0 3 5 3
Draw line... 0 2 5 2
Draw line... 0 1 5 1


